Bug 134108 - net/quagga: bgpd aborts on receiving ASN32 announces
net/quagga: bgpd aborts on receiving ASN32 announces
Status: Closed FIXED
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s)
Any Any
: Normal Affects Only Me
Assigned To: Wesley Shields
Depends on:
  Show dependency treegraph
Reported: 2009-04-30 11:00 UTC by eugen
Modified: 2009-05-04 15:41 UTC (History)
0 users

See Also:

quagga.patch (16.40 KB, patch)
2009-05-03 21:31 UTC, g.veniamin
no flags Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description eugen 2009-04-30 11:00:13 UTC
	Today bgpd on my BGP router started to break with abort()
	just after start of receiving BGP full view with messages in logs:

bgpd[1156]: Assertion `len < str_size' failed in file bgp_aspath.c, line 619, function aspath_make_str_count
bgpd[1156]: No backtrace available on this platform.
kernel: pid 1156 (bgpd), uid 101: exited on signal 6

	There was discussion of this buf in quagga-users@ mailing list
	3 February 2009 that presented a patch but the patch did not hit
	quagga's git repository yet.



Add the patch taken from quagga-users@ mailing list
	to FreeBSD Ports Repository at /usr/ports/net/quagga/files/
	until permanent fix hit quagga's repo.


Eugene Grosbein
	Run quagga with BGP enabled and try to receive BGP full view.
Comment 1 g.veniamin 2009-05-03 21:31:28 UTC
XMMP: zloidemon@jabber.ru
Comment 2 Wesley Shields freebsd_committer 2009-05-03 23:50:41 UTC
Responsible Changed
From-To: freebsd-ports-bugs->wxs

I'll take it.
Comment 3 Wesley Shields freebsd_committer 2009-05-03 23:51:51 UTC
ports/134108 has been submitted. As the maintainer of this port would
you please take a look at this PR and either accept or reject the patch
provided. Thank you.


-- WXS
Comment 4 Wesley Shields freebsd_committer 2009-05-03 23:52:04 UTC
State Changed
From-To: open->feedback

Asked maintainer for approval.
Comment 5 boris 2009-05-04 13:11:43 UTC
Agreed. Please commit it ASAP.

Comment 6 pmialon 2009-05-04 14:12:48 UTC

We have build two package with the patch submitted one for i386 and one for 

Everything work on AMD64.

On i386 the ospfd stop with following messages :

May  3 15:56:49 host ospfd[61903]: ASBR[Status:1]: Update
May  3 15:56:49 host ospfd[61903]: ASBR[Status:2]: Update
May  3 15:56:49 host ospfd[61903]: ASBR[Status:2]: Already ASBR
May  3 15:56:49 host ospfd[61903]: ASBR[Status:3]: Update
May  3 15:56:49 host ospfd[61903]: ASBR[Status:3]: Already ASBR
May  3 15:56:49 host ospfd[61904]: OSPFd 0.99.11 starting: vty@2604
May  3 15:56:49 host ospfd[61904]: Received signal 4 at 1241359009 (si_addr 
0x2809506a); aborting...

We have replace /usr/local/sbin/ospfd and /usr/local/lib/libospf.so.0 by the 
previous version (build with unpatched ports of quagga-0.9.99_1) and 
everything work again. 

Our router are NanoBSD boxes running1 7.1-RELEASE-p2.


Pierre-Gilles Mialon
Linagora :: http://www.linagora.com
Responsable hébergement :: Head of Hosting services
pmialon@linagora.com :: +33.1 58 18 65 46
Comment 7 Wesley Shields freebsd_committer 2009-05-04 14:30:47 UTC

Thanks for the approval but it appears there is a problem with the port
on i386 (see the log of the PR for details). Can you please take a look
at this and let me know if you can reproduce it and/or if you have a

-- WXS
Comment 8 Wesley Shields freebsd_committer 2009-05-04 15:10:22 UTC
The broken i386 port was compiled with:


-- WXS
Comment 9 Wesley Shields freebsd_committer 2009-05-04 15:28:49 UTC
The problem with i386 has been attributed to a local problem with the
submitter. I will get this patch in the tree shortly. Thank you again
for being responsive in this matter.

-- WXS
Comment 10 dfilter freebsd_committer 2009-05-04 15:37:57 UTC
wxs         2009-05-04 14:37:48 UTC

  FreeBSD ports repository

  Modified files:
    net/quagga           Makefile 
  Added files:
    net/quagga/files     patch-bgp_aspath.c patch-bgp_attr.c 
                         patch-bgp_community.c patch-bgp_debug.c 
                         patch-bgp_ecommunity.c patch-bgp_packet.c 
                         patch-bgp_route.c patch-bgp_vty.c 
  - Fix bgpd crash. More information is at:
    This crash can be triggered remotely.
  PR:             ports/134108
  Submitted by:   Eugene Grosbein <eugen@eg.svzserv.kuzbass.ru>
  Approved by:    Boris Kovalenko <boris@tagnet.ru> (maintainer)
  Revision  Changes    Path
  1.83      +1 -1      ports/net/quagga/Makefile
  1.1       +127 -0    ports/net/quagga/files/patch-bgp_aspath.c (new)
  1.1       +11 -0     ports/net/quagga/files/patch-bgp_attr.c (new)
  1.1       +11 -0     ports/net/quagga/files/patch-bgp_community.c (new)
  1.1       +10 -0     ports/net/quagga/files/patch-bgp_debug.c (new)
  1.1       +20 -0     ports/net/quagga/files/patch-bgp_ecommunity.c (new)
  1.1       +38 -0     ports/net/quagga/files/patch-bgp_packet.c (new)
  1.1       +38 -0     ports/net/quagga/files/patch-bgp_route.c (new)
  1.1       +76 -0     ports/net/quagga/files/patch-bgp_vty.c (new)
  1.1       +45 -0     ports/net/quagga/files/patch-bgpd.c (new)
cvs-all@freebsd.org mailing list
To unsubscribe, send any mail to "cvs-all-unsubscribe@freebsd.org"
Comment 11 Wesley Shields freebsd_committer 2009-05-04 15:41:45 UTC
State Changed
From-To: feedback->closed

Committed. Thanks!